package com.cicdi.notify;

import com.cicdi.notify.template.Template;

/**
 * 通知器管理器，用于获取获取通知器
 *
 * @author xueye
 */
public interface NotifierManager {

    /**
     * @param type 通知类型 {@link NotifyType}
     * @param id   通知器唯一标识
     * @param <T>  通知模板类型
     * @return 通知器
     * @see NotifierProvider
     */
    <T extends Template> Notifier<T> getNotifier(NotifyType type, String id);

    /**
     * 注册通知服务商
     * <p>服务商经过注册之后才可以使用, 如果通知模板配置的服务商不在已注册集合中, 将会抛出{@link UnsupportedOperationException}</p>
     *
     * @param provider 通知服务商
     * @see UnsupportedOperationException
     */
    void register(NotifierProvider provider);

    /**
     * 重新加载通知管理器
     *
     * @param id 通知管理器ID
     */
    void reload(String id);

}
