package com.cicdi.notify;

import com.cicdi.notify.template.Template;

/**
 * 通知服务商
 *
 * @author xueye
 */
public interface NotifierProvider {
    /**
     * 获取通知类型
     *
     * @return 通知类型
     * @see NotifyType
     */
    NotifyType getType();

    /**
     * 获取通知器服务商
     *
     * @return 服务商标识
     */
    Provider getProvider();

    /**
     * 根据通知器配置属性创建通知器
     *
     * @param properties 通知配置属性
     * @return 通知器
     */
    Notifier<? extends Template> createNotifier(NotifierProperties properties);

//    /**
//     * 获取通知配置元数据,通过元数据可以知道此通知所需要的配置信息
//     *
//     * @return 配置元数据
//     */
//    default ConfigMetadata getNotifierConfigMetadata() {
//        return null;
//    }
}
