package com.cicdi.notify.template;

import com.cicdi.notify.DefaultNotifyType;
import com.cicdi.notify.NotifyType;
import com.cicdi.notify.Provider;

/**
 * 通知模板服务商
 * <p>模板服务商用于生成对应服务商支持的通知模板</p>
 *
 * @author xueye
 * @see Template
 */
public interface TemplateProvider {

    /**
     * @return 通知类型
     * @see NotifyType
     * @see DefaultNotifyType
     */
    NotifyType getType();

    /**
     * 获取模板的服务商
     *
     * @return 模板服务商
     */
    Provider getProvider();

    /**
     * 根据通知模板配置属性生成通知模板
     *
     * @param properties 通知模板配置属性
     * @return 通知模板
     */
    Template createTemplate(TemplateProperties properties);

}
