package com.cicdi.notify.dingtalk;

import com.alibaba.fastjson.JSON;
import com.cicdi.notify.*;
import com.cicdi.notify.template.TemplateManager;
import com.cicdi.notify.template.TemplateProperties;
import com.cicdi.notify.template.TemplateProvider;

import java.util.Objects;


public class DingTalkNotifierProvider implements NotifierProvider, TemplateProvider {

    private final TemplateManager templateManager;

    public DingTalkNotifierProvider(TemplateManager templateManager) {
        this.templateManager = templateManager;
    }

//    public static final DefaultConfigMetadata notifierConfig = new DefaultConfigMetadata("通知配置", "")
//        .add("appKey", "appKey", "", new StringType().expand(ConfigMetadataConstants.required.value(true)))
//        .add("appSecret", "appSecret", "", new StringType());
//
//    public static final DefaultConfigMetadata templateConfig = new DefaultConfigMetadata("模版配置", "")
//        .add("agentId", "应用ID", "", new StringType().expand(ConfigMetadataConstants.required.value(true)))
//        .add("userIdList", "收信人ID", "与部门ID不能同时为空", new StringType())
//        .add("departmentIdList", "收信部门ID", "与收信人ID不能同时为空", new StringType())
//        .add("toAllUser", "全部用户", "推送到全部用户", new BooleanType())
//        .add("message", "内容", "最大不超过500字", new StringType().expand(ConfigMetadataConstants.maxLength.value(500L)));

    @Override
    public NotifyType getType() {
        return DefaultNotifyType.dingTalk;
    }

    @Override
    public Provider getProvider() {
        return DingTalkProvider.dingTalkMessage;
    }

    @Override
    public DingTalkMessageTemplate createTemplate(TemplateProperties properties) {
//         return ValidatorUtils.tryValidate(JSON.parseObject(properties.getTemplate(), DingTalkMessageTemplate.class));
        return JSON.parseObject(properties.getTemplate(), DingTalkMessageTemplate.class);
    }

    @Override
    public DingTalkNotifier createNotifier(NotifierProperties properties) {
        DingTalkProperties dingTalkProperties = new DingTalkProperties();
        dingTalkProperties.setAppKey((String) Objects.requireNonNull(properties.getConfiguration().get("appKey"), "appKey不能为空"));
        dingTalkProperties.setAppSecret((String) Objects.requireNonNull(properties.getConfiguration().get("appSecret"), "appSecret不能为空"));
        return new DingTalkNotifier(properties.getId(), dingTalkProperties, templateManager);
//        return new DingTalkNotifier(properties.getId(), ValidatorUtils.tryValidate(dingTalkProperties), templateManager);
    }

//    @Override
//    public ConfigMetadata getNotifierConfigMetadata() {
//        return notifierConfig;
//    }
//
//    @Override
//    public ConfigMetadata getTemplateConfigMetadata() {
//        return templateConfig;
//    }
}
