package com.cicdi.notify.dingtalk;

import com.alibaba.fastjson.JSONObject;
import com.cicdi.notify.*;
import com.cicdi.notify.template.AbstractTemplateManager;
import com.cicdi.notify.template.Template;
import com.cicdi.notify.template.TemplateManager;
import com.cicdi.notify.template.TemplateProperties;
import org.junit.Test;

import java.util.HashMap;
import java.util.Map;

/**
 * @author xueye
 */
public class DingTalkTest {
    @Test
    public void test() {
        // 通知器配置管理器
        NotifyConfigManager notifyConfigManager = (notifyType, configId) -> {
            NotifierProperties notifierProperties = new NotifierProperties();
            notifierProperties.setType(DefaultNotifyType.dingTalk.getId());
            notifierProperties.setProvider(DingTalkProvider.dingTalkMessage.getId());
            notifierProperties.setId("12");

            Map<String, Object> config = new HashMap<>();
            config.put("appKey", "dinga5vkkpbrwqc0fmni");
            config.put("appSecret", "ARsEfA8CQ7RxJabEW1TecTeEItTamK3GQ8-TfWTHAydF7gQK16N23UuN9y2E9raq");

            notifierProperties.setConfiguration(config);

            return notifierProperties;
        };

        // 模板管理器
        TemplateManager templateManager = new AbstractTemplateManager() {
            @Override
            protected TemplateProperties getProperties(NotifyType type, String id) {
                TemplateProperties templateProperties = new TemplateProperties();
                templateProperties.setType(DefaultNotifyType.dingTalk.getId());
                templateProperties.setProvider(DingTalkProvider.dingTalkMessage.getId());

                JSONObject jsonObject = new JSONObject();
                jsonObject.put("agentId", "1211676948");
                jsonObject.put("userIdList", "manager276");
                jsonObject.put("departmentIdList", "");
                jsonObject.put("toAllUser", "false");
                jsonObject.put("message", "Hello World!");

                templateProperties.setTemplate(jsonObject.toJSONString());

                return templateProperties;
            }
        };

        NotifierManager notifierManager = new AbstractNotifierManager(notifyConfigManager){};

        // register
        DingTalkNotifierProvider provider = new DingTalkNotifierProvider(templateManager);
        notifierManager.register(provider);
        templateManager.register(provider);

        Notifier<Template> notifier = notifierManager.getNotifier(DefaultNotifyType.dingTalk, "123");
        notifier.send(templateManager.getTemplate(DefaultNotifyType.dingTalk, "124"), new HashMap<>());
    }
}
