package com.cicdi.notify.wechat;


import com.alibaba.fastjson.JSONObject;
import com.cicdi.notify.template.Template;
import org.apache.commons.lang.StringUtils;

import java.util.Collections;
import java.util.Map;

public class WechatMessageTemplate implements Template {

    /**
     * 应用ID
     */
    private String agentId;

    private String toUser;

    private String toParty;

    private String toTag;

    private String message;

    public String getAgentId() {
        return agentId;
    }

    public void setAgentId(String agentId) {
        this.agentId = agentId;
    }

    public String getToUser() {
        return toUser;
    }

    public void setToUser(String toUser) {
        this.toUser = toUser;
    }

    public String getToParty() {
        return toParty;
    }

    public void setToParty(String toParty) {
        this.toParty = toParty;
    }

    public String getToTag() {
        return toTag;
    }

    public void setToTag(String toTag) {
        this.toTag = toTag;
    }

    public String getMessage() {
        return message;
    }

    public void setMessage(String message) {
        this.message = message;
    }

    public String createJsonRequest(Map<String, Object> context) {
        JSONObject json = new JSONObject();
        json.put("agentid", getAgentId());
        json.put("msgtype", "text");
        // TODO
//        json.put("text",Collections.singletonMap("content",ExpressionUtils.analytical(message, context.getAllValues(), "spel")));
        json.put("text", Collections.singletonMap("content", message));

        if (StringUtils.isNotBlank(toUser)) {
            json.put("touser", this.createUserIdList(context));
        }
        if (StringUtils.isNotBlank(toParty)) {
            json.put("toparty", this.createDepartmentIdList(context));
        }

        return json.toJSONString();
    }

    public String createUserIdList(Map<String, Object> context) {
        if (StringUtils.isEmpty(toUser)) {
            return toUser;
        }
        return toUser;
//        return ExpressionUtils.analytical(toUser, context.getAllValues(), "spel");
    }

    public String createDepartmentIdList(Map<String, Object> context) {
        if (StringUtils.isEmpty(toParty)) {
            return toParty;
        }
        return toParty;
//        return ExpressionUtils.analytical(toParty, context.getAllValues(), "spel");
    }

    public String createMessage(Map<String, Object> context) {
        JSONObject json = new JSONObject();
        json.put("content", message);
//        json.put("content", ExpressionUtils.analytical(message, context.getAllValues(), "spel"));
        return json.toJSONString();
    }

}
